// TODO - don't pass oDevice between models.
// Top level piece for the Smart Array page.
var VConfiguration = AVBody.extend({
   
   render: function() {
      var oNavDiv = $('<div/>', {'class':'tab1Nav'});
      var oBodyDiv = $('<div/>', {'class':'tab1Body'});
      this.$el.append(oNavDiv);
      this.$el.append(oBodyDiv);
      var oMNav = new MConfigurationNav({ 
         "sDeviceID": this.model.get("sDeviceID"), 
         "oDevice": this.model.get("oDevice"),
         "sSelectedTab": this.model.get("sTab")
      });
      this.oVNav = new VConfigurationNav({ el: oNavDiv, model: oMNav });
      var sTab = this.model.get("sTab");
      if (!IsDefinedAndSet(sTab) || sTab == "controller")
      {
         this.clickController();
      }
      /*else if (sTab == "status")
      {
         this.clickStatus();
      }*/
      else
      {
         var sDeviceType;
         if (sTab == "arrays")
         {
            sDeviceType = "TypeLogicalArray";
            //sLabel = "STR_ARRAYS";
         }
         else if (sTab == "logical_drives")
         {
            sDeviceType = "TypeLogicalDrive";
            //sLabel = "STR_LOGICAL_DRIVES";
            //sIconClass = "ICON_DATA_LOGICAL_DRIVES";
         }
         else if (sTab == "assigned_drives")
         {
            sDeviceType = "TypeAssignedDrive";
            //sLabel = "STR_ASSIGNED_DRIVES";
            //sIconClass = "ICON_ASSIGNED_DRIVES";
         }
         else if (sTab == "unassigned_drives")
         {
            sDeviceType = "TypeUnassignedDrive";
            //sLabel = "STR_UNASSIGNED_DRIVES";
            //sIconClass = "ICON_UNASSIGNED_DRIVES";
         }
         else if (sTab == "encryption_manager")
         {
            sDeviceType = "TypeEncryptionManager";
            //sLabel = "STR_ENCRYPTION_MANAGER";
         }
         else if (sTab == "cache_manager")
         {
            sDeviceType = "TypeCacheManager";
            //sLabel = "STR_CACHE_MANAGER";
         }
         else if (sTab == "license_manager")
         {
            sDeviceType = "TypeLicenseManager";
            //sLabel = "STR_LICENSE_MANAGER";
         }
         if (IsDefined(sDeviceType))
         {
            this.clickDeviceContainer(sTab, sDeviceType);
         }
      }
      return this;
   },
   
   clickController: function() {
      var oModel = new MSAController({
         "sDeviceID": this.model.get("sDeviceID"),
         "oDevice": this.model.get("oDevice"),
         "sTab": this.model.get("sTab1"),
         "sTab1": this.model.get("sTab2")
      });
      var oVT = new VSAController({ 
         el: this.loadTab("SAController", ""), 
         model: oModel
      });
      this.oVTab = oVT;
   },
   
   clickDeviceContainer: function(sTab, sDeviceType) {
      var sDeviceID = this.model.get("sDeviceID");
      if (sDeviceType == "TypeLogicalArray")
      {
         var oModel = new MArraysTreeActions({
            "sDeviceID": sDeviceID,
            "sTab": this.model.get("sTab1")
         });
         var oVT = new VArraysTreeActions({
            el: this.loadTab(sTab, "tab1BodyInner noBorder"),
            model: oModel
         });
      }
      else if (sDeviceType == "TypeEncryptionManager")
      {
         var oModel = new MEncryptionManager({
            "sDeviceID": sDeviceID,
            "sTab": this.model.get("sTab1"),
            "sTab1": this.model.get("sTab2")            
         });
         var oVT = new VEncryptionManager({ 
            el: this.loadTab("EncryptionManager", ""), 
            model: oModel
         });
         this.oVTab = oVT;
      }
      else if (sDeviceType == "TypeCacheManager")
      {
         sDeviceID += ":CM";
         var oModel = new MCacheManagerTreeActions({
            "sDeviceID": sDeviceID,
            "sTab": this.model.get("sTab1")
         });
         var oVT = new VCacheManagerTreeActions({
            el: this.loadTab(sTab, "tab1BodyInner noBorder"),
            model: oModel
         });
      }
      else if (sDeviceType == "TypeLicenseManager")
      {
         sDeviceID += ":LM";
         var oModel = new MLicenseManagerTreeActions({
            "sDeviceID": sDeviceID,
            "sTab": this.model.get("sTab1")
         });
         var oVT = new VLicenseManagerTreeActions({
            el: this.loadTab(sTab, "tab1BodyInner noBorder"),
            model: oModel
         });
      }
      else if (sDeviceType == "TypeUnassignedDrive")
      {
         var oModel = new AMDeviceContainer({
            "sDeviceID": sDeviceID,
            "sType": sDeviceType,
            "sLabel": "STR_UNASSIGNED_DRIVES",
            "sIconClass": "ICON_UNASSIGNED_DRIVES",
            "sTab": this.model.get("sTab1")
         });
         var oVT = new AVDeviceContainer({ 
            el: this.loadTab(sTab, "tab1BodyInner"),
            model: oModel
         });
      }
      this.oVTab = oVT;
   }
});