var MConfigurationDeviceTabLink = AMTabLink.extend({

   initialize: function(){
   },
   
   refresh: function() {
      this.set({
         'oDevice': null
      });
      this.update(true); // Fetch device update from server.
   },
   
   update: function(bFetch){
      var oDevice = this.get('oDevice');
      if (!IsDefined(oDevice))
      {
         GetDeviceDetails(
            this.get('sDeviceID'),
            2,
            function(o){
               var oDevice = o.device;
               this.updateTab(oDevice);
            },
            true,
            this,
            bFetch);
      }
      else
      {
         this.updateTab(oDevice);
      }
   },
   
   updateTab: function(oDevice){
      if (!IsDefined(oDevice))
      {
         oDevice = this.get('oDevice');
      }
      var oStatus;
      var nStatusCount = 0;
      var sStatusCountClass = '';
      if (oDevice.length > 0)
      {
         oStatus = oDevice[oDevice.length-1];
      }
      if (IsDefined(oStatus))
      {
         sStatusCountClass = GetStatusOverlayClass(oStatus);
         if (IsDefined(oStatus.STATUS_COUNT_TOTAL))
         {
            nStatusCount = oStatus.STATUS_COUNT_TOTAL;
         }
      }
      var oSection = oDevice[0];
      
      // Add status overlay icon if applicable.
      // The set after this will trigger render, so setting the overlay icon must come first.
      var sIconStatusOverlayClass = oSection.ICON_OVERLAY_STATUS;
      var sIconStateOverlayClass = oSection.ICON_OVERLAY_STATE;
      
      this.set({
         'sIcon':oSection.ICON,
         'sName':oSection.NAME,
         'sType':"TypeSmartArrayController",
         'sDescription':oSection.LOCATION,
         'sIconStatusOverlayClass':sIconStatusOverlayClass,
         'sIconStateOverlayClass':sIconStateOverlayClass,
         'nStatusCount':nStatusCount,
         'sStatusCountClass':sStatusCountClass,
         'oDevice':oDevice,
         'bUpdated':true
      });
   }
});